VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.UserControl IcqSms 
   ClientHeight    =   3525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3900
   InvisibleAtRuntime=   -1  'True
   Picture         =   "ctrlIcqSms.ctx":0000
   ScaleHeight     =   3525
   ScaleWidth      =   3900
   ToolboxBitmap   =   "ctrlIcqSms.ctx":0BE2
   Begin VB.PictureBox Icon 
      Appearance      =   0  'Flat
      BackColor       =   &H80000004&
      ForeColor       =   &H80000008&
      Height          =   525
      Left            =   0
      Picture         =   "ctrlIcqSms.ctx":0EF4
      ScaleHeight     =   495
      ScaleWidth      =   510
      TabIndex        =   1
      Top             =   0
      Width           =   540
   End
   Begin VB.TextBox HTML 
      Appearance      =   0  'Flat
      BackColor       =   &H80000004&
      Enabled         =   0   'False
      Height          =   2715
      Left            =   45
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   570
      Visible         =   0   'False
      Width           =   3780
   End
   Begin MSWinsockLib.Winsock socket 
      Left            =   810
      Top             =   165
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
End
Attribute VB_Name = "IcqSms"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

Option Explicit

'Default Property Values:
Const m_def_UIN = 0
Const m_def_Password = ""

'Property Variables:
Dim m_UIN              As Long
Dim m_Password         As String

'Event Declarations:
Event Status(SMSOutput As SMSStatus)
Event LoggedIn(SuccesFull As Boolean)
Event LoggedOut(SuccesFull As Boolean)
Event TimeOut(Action As String)
Event SMSSent(TotalMessages As Integer)
Event SMSError(Number As Integer, Description As String)

Private SMS_BUSY         As Boolean
Private BombCount        As Long
Private TotalMessages    As Integer
Private tmpTimeOut       As Boolean
Private TimeOutCounter   As Integer

Public Enum SMSStatus
    Disconnected = 0
    Connecting = 1
    Connected = 2
    LoggedIn = 3
    LoggedOut = 4
    SendingSMS = 5
    SMSSent = 6
    SendingCanceled = 7
    TimeOut = 187
End Enum




Public Sub Login()
    
    If Len(UIN) <= 0 Then
        tmpError (10001)
        Exit Sub
    End If
    If Password = "" Then
        tmpError (10002)
        Exit Sub
    End If
    
    SMS_PREFIX& = 0
    SMS_TOPHONE& = 0
    SMS_MESSAGE$ = ""
    SMS_CHARACTERS = 0
    Status = LogMeIn
    SMS_BUSY = True
    socket.Close
    socket.Connect "205.188.248.57", 80
    RaiseEvent Status(Connecting)
End Sub

Public Sub LogOut()
    Call Reset
End Sub

Public Sub CancelSending()
    BombCount& = 0
    SMS_PREFIX& = 0
    SMS_TOPHONE& = 0
    SMS_MESSAGE$ = ""
    SMS_CHARACTERS = 0
    HTML.Text = ""
    socket.Close
    SMS_BUSY = False
    RaiseEvent Status(SendingCanceled)
End Sub

Public Sub Reset()
    socket.Close
    UIN = 0
    Password = ""
    BombCount& = 0
    SMS_PREFIX& = 0
    SMS_TOPHONE& = 0
    SMS_MESSAGE$ = ""
    SMS_CHARACTERS = 0
    HTML.Text = ""
    HTML_ID$ = ""
    Status = LogMeIn
    SMS_BUSY = False
    RaiseEvent LoggedOut(True)
    RaiseEvent Status(Disconnected)
End Sub

Public Sub SendSMS(CountryCode As Long, _
                   PhoneNumber As Long, _
                   SmsMessage As String)
    
    If Status = LogMeIn Then
        tmpError (10007)
        Call Reset
    End If
    If SMS_BUSY = True Then
        tmpError (10003)
        Exit Sub
    End If
    If Len(CountryCode&) <= 0 Or CountryCode& = 0 Then
        tmpError (10004)
        Exit Sub
    End If
    If Len(PhoneNumber&) <= 0 Or PhoneNumber& = 0 Then
        tmpError (10005)
        Exit Sub
    End If
    If SmsMessage$ = "" Then
        tmpError (10006)
        Exit Sub
    End If
    
    SMS_PREFIX& = CountryCode&
    SMS_TOPHONE& = PhoneNumber&
    SMS_MESSAGE$ = SmsMessage$
    SMS_CHARACTERS = 160 - Len(SMS_MESSAGE$)
    SMS_BUSY = True
    RaiseEvent Status(SendingSMS)
    socket.Connect "205.188.248.57", 80
End Sub



Public Sub SendSMSBomb(CountryCode As Long, _
                       PhoneNumber As Long, _
                       SmsMessage As String, _
                       BombValue As Long)
    
    If Status = LogMeIn Then
        tmpError (10007)
        Call Reset
    End If
    If SMS_BUSY = True Then
        tmpError (10003)
        Exit Sub
    End If
    If Len(CountryCode&) <= 0 Or CountryCode& = 0 Then
        tmpError (10004)
        Exit Sub
    End If
    If Len(PhoneNumber&) <= 0 Or PhoneNumber& = 0 Then
        tmpError (10005)
        Exit Sub
    End If
    If SmsMessage$ = "" Then
        tmpError (10006)
        Exit Sub
    End If
    If SMS_CHARACTERS > 160 Then
        tmpError (10008)
        Exit Sub
    End If
    If BombValue& <= 0 Or Len(BombValue&) = 0 Then
        BombCount& = 1
    Else
        BombCount& = BombValue&
    End If
    
    
    SMS_PREFIX& = CountryCode&
    SMS_TOPHONE& = PhoneNumber&
    SMS_MESSAGE$ = SmsMessage$
    SMS_CHARACTERS = 160 - Len(SMS_MESSAGE$)
    SMS_BUSY = True
    socket.Connect "205.188.248.57", 80
End Sub



Private Sub socket_Connect()

    Select Case Status
        Case 0
                RaiseEvent Status(SMSStatus.Connected)
                socket.SendData DoLogin(UIN, Password)
        Case 1
            If Status = SMSReady Then
                RaiseEvent Status(SendingSMS)
                tmpTimeOut = True
                socket.SendData Send_SMS
                
                ' check for server timeout (20 secs)
                 Dim tTime As Long
                    tTime = Timer()
                     DoEvents
                    While Timer() - tTime < 20
                        If tmpTimeOut = False Then
                            Exit Sub
                        End If
                     DoEvents
                    Wend
                     DoEvents
                    
                     TimeOutCounter% = TimeOutCounter% + 1
                        If TimeOutCounter% >= 3 Then
                            TimeOutCounter% = 0
                            socket.Close
                            BombCount& = 0
                            RaiseEvent TimeOut("Sending stopped: No server response. (60 seconds)")
                        Else
                            TimeOutCounter% = 0
                            socket.Close
                            socket.Connect "205.188.248.57", 80
                            RaiseEvent TimeOut("Resending (" & TimeOutCounter% & "): No server response. (20 seconds)")
                            BombCount& = 0
                        End If
                        
            Else
                tmpError (10007)
                Call Reset
            End If
            
    End Select
    
End Sub

Private Sub socket_DataArrival(ByVal bytesTotal As Long)
 Dim tmpdata As String
 
    socket.GetData tmpdata$, vbString
    HTML = HTML & vbCrLf & tmpdata$
    
        If Status = LogMeIn Then
            
                If InStr(1, HTML, "KarmaLogin=", vbTextCompare) > 0 Then
                    Dim tmpHTML_ID As String
                        tmpHTML_ID$ = Split(HTML, "; path=")(0)
                        tmpHTML_ID$ = Split(tmpHTML_ID$, "KarmaLogin=")(1)
                        
                        HTML_ID$ = "uin=" & UIN & _
                                   "; " & _
                                   "KarmaLogin=" & tmpHTML_ID$ & _
                                   "; KarmaService1=Yes"
                        
                        Status = SMSReady
                        socket.Close
                        HTML.Text = ""
                        
                        SMS_BUSY = False
                        RaiseEvent Status(SMSStatus.LoggedIn)
                        RaiseEvent LoggedIn(True)
                        Exit Sub
                End If
        
        
        Else
        
                If InStr(1, HTML, "Location: /sms/send_history/1,,,00.html?", vbTextCompare) > 0 Then
                    
                    tmpTimeOut = False
                    TotalMessages% = TotalMessages% + 1
                    RaiseEvent SMSSent(TotalMessages%)
                    
                        If BombCount& > 0 Then
                            BombCount& = BombCount& - 1
                            HTML.Text = ""
                            RaiseEvent Status(SMSSent)
                            socket.Close
                            socket.Connect "205.188.248.57", 80
                            Exit Sub
                        Else
                            SMS_PREFIX& = 0
                            SMS_TOPHONE& = 0
                            SMS_MESSAGE$ = ""
                            SMS_CHARACTERS = 0
                            HTML.Text = ""
                            socket.Close
                            SMS_BUSY = False
                            RaiseEvent Status(SMSSent)
                            Exit Sub
                        End If
                        
                Else
                        RaiseEvent TimeOut("Unknown server reply. Resending...")
                        HTML.Text = ""
                        socket.Close
                        socket.Connect "205.188.248.57", 80
                        Exit Sub
                End If
        
        
        End If
        
        
        If InStr(1, HTML, "Location: /sms/login/", vbTextCompare) > 0 Then
            tmpError (10009)
            Call Reset
            Exit Sub
        End If
        
        
End Sub

Private Sub socket_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    RaiseEvent SMSError(Number%, Description$)
End Sub


Private Sub tmpError(Number As Integer)
 Dim Output As String
 
    Select Case Number%
        
        Case 10001: Output$ = "Cannot login without ICQ Number(UIN)"
        Case 10002: Output$ = "Cannot login without Password"
        Case 10003: Output$ = "Cannot send message, still sending..."
        Case 10004: Output$ = "Cannot send without Countrycode."
        Case 10005: Output$ = "Cannot send without PhoneNumber."
        Case 10006: Output$ = "Cannot send a blank Message."
        Case 10007: Output$ = "Cannot send sms while status is logged out."
        Case 10008: Output$ = "Message to long. Maximum of 160 caracters allowed in a message."
        Case 10009: Output$ = "Invalid ICQ Number or Password."
        
    End Select
    
        RaiseEvent SMSError(Number%, Output$)
        
End Sub





Private Sub UserControl_Initialize()
    UserControl.Height = 450
    UserControl.Width = 525
    Set Events = Me
    UserControl.Picture = Icon.Picture
End Sub

Private Sub UserControl_Resize()
      UserControl.Height = 525
      UserControl.Width = 540
End Sub

Private Sub UserControl_InitProperties()
    m_UIN = m_def_UIN
    m_Password = m_def_Password
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_UIN = PropBag.ReadProperty("UIN", m_def_UIN)
    m_Password = PropBag.ReadProperty("Password", m_def_Password)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("UIN", m_UIN, m_def_UIN)
    Call PropBag.WriteProperty("Password", m_Password, m_def_Password)
End Sub





Public Property Get UIN() As Variant
    UIN = m_UIN
End Property

Public Property Let UIN(ByVal New_UIN As Variant)
    m_UIN = New_UIN
    PropertyChanged "UIN"
End Property

Public Property Get Password() As Variant
    Password = m_Password
End Property

Public Property Let Password(ByVal New_Password As Variant)
    m_Password = New_Password
    PropertyChanged "Password"
End Property

